#
# Spec file for prolinga-run (stand-alone)
#
Summary: 	ProLinga run-time interpreter engine.
Name: 		prolinga-run
Version: 	0.0.2
Release: 	1.sa.fc11.xobas
License: 	GPL
Group:		System Environment/Libraries
Source: 	http://download.prolinga.org/main/sources/%{name}-%{version}.tar.bz2
Patch0:		%{name}-%{version}_libgda41_32.patch
Patch1:		%{name}-%{version}_libgda41_64.patch
Patch2:		%{name}-%{version}_memfix.patch
URL: 		http://www.xobas.com/
Vendor: 	Xobas Software
Packager: 	Bas Driessen <bas.driessen@prolinga.com>
BuildRoot: 	%{_tmppath}/%{name}-%{version}-root
Requires: 	gtk2 >= 2.4.0
Requires: 	libglade2 >= 2.4.0
Requires: 	libxml2 >= 2.6.5
Requires: 	prolinga-calc >= 0.0.2
Requires: 	prolinga-data >= 0.0.2
Requires: 	prolinga-soap >= 0.0.2
Requires: 	prolinga-repository >= 0.0.2
Requires: 	prolinga-validate >= 0.0.2

%description
ProLinga-Run is a run-time engine. It is an interpreter 
that processes XML documents generated from 4GL logic 
statements by ProLinga-Validate. 4GL statements include 
bindings to the popular GTK+ User Interface for the 
Linux (GNOME) desktop.

%package server
Summary:	prolinga-run daemon.
Group:		System Environment/Libraries
Requires:	libxml2 >= 2.6.5
Requires: 	prolinga-calc >= 0.0.2
Requires: 	prolinga-data >= 0.0.2
Requires: 	prolinga-soap >= 0.0.2
Requires: 	prolinga-repository >= 0.0.2
Requires: 	prolinga-validate >= 0.0.2

%description server
This package contains the run daemon.

%package devel
Summary:	Development libraries and header files for prolinga-run.
Group:		Development/Libraries
Requires:	%name-libs = %{version}
Requires:	%name = %{version}
Requires: 	gtk2 >= 2.4.0
Requires: 	gtk2-devel >= 2.4.0
Requires: 	libglade2 >= 2.4.0
Requires: 	libglade2-devel >= 2.4.0
Requires: 	libxml2 >= 2.6.5
Requires: 	libxml2-devel >= 2.6.5
Requires: 	prolinga-calc >= 0.0.2
Requires: 	prolinga-calc-devel >= 0.0.2
Requires: 	prolinga-data >= 0.0.2
Requires: 	prolinga-data-devel >= 0.0.2
Requires: 	prolinga-soap >= 0.0.2
Requires: 	prolinga-soap-devel >= 0.0.2
Requires: 	prolinga-repository >= 0.0.2
Requires: 	prolinga-repository-devel >= 0.0.2
Requires: 	prolinga-validate >= 0.0.2
Requires: 	prolinga-validate-devel >= 0.0.2

%description devel
This package contains the header files and libraries needed to write
or compile programs that use prolinga-run.

%prep
%setup -q
if [ "%_lib" = "lib64" ]; then
%patch1 -p1
else
%patch0 -p1
fi
%patch2 -p1

%build
./bootstrap
%configure \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--enable-local-data \
	--enable-local-repository \
	--enable-local-validate
make
make html

%install
rm -rf %{buildroot}
%makeinstall

# Put startup script in the right place.
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d/
install -m 755 %{_builddir}/%{name}-%{version}/prolinga/prolingarund.init %{buildroot}%{_sysconfdir}/rc.d/init.d/prolingarund

# Set hostname to localhost in config file.
sed -e "s?`(hostname || uname -n) 2>/dev/null | sed 1q`<?localhost<?g" < %{buildroot}%{_sysconfdir}/prolingaruncfg.xml > %{_tmppath}/prolingaruncfg.tmp
mv %{_tmppath}/prolingaruncfg.tmp %{buildroot}%{_sysconfdir}/prolingaruncfg.xml

# Set Repository system path
sed -e "s?<SystemPath>.*?<SystemPath>%{_localstatedir}/lib/prolinga/system</SystemPath>?g" < %{buildroot}%{_sysconfdir}/prolingaruncfg.xml > %{_tmppath}/prolingaruncfg.tmp
mv %{_tmppath}/prolingaruncfg.tmp %{buildroot}%{_sysconfdir}/prolingaruncfg.xml

# Set Language Validation path
sed -e "s?<LanguageValidationFile>.*?<LanguageValidationFile>%{_datadir}/prolinga/langvalid.xml</LanguageValidationFile>?g" < %{buildroot}%{_sysconfdir}/prolingaruncfg.xml > %{_tmppath}/prolingaruncfg.tmp
mv %{_tmppath}/prolingaruncfg.tmp %{buildroot}%{_sysconfdir}/prolingaruncfg.xml

%clean
rm -rf %{buildroot}

%post
# update library links
/sbin/ldconfig

# Change hostname from localhost to real hostname in config file.
sed -e "s?localhost<?`(hostname || uname -n) 2>/dev/null | sed 1q`<?g" < %{_sysconfdir}/prolingaruncfg.xml > %{_tmppath}/prolingaruncfg.tmp
mv %{_tmppath}/prolingaruncfg.tmp %{_sysconfdir}/prolingaruncfg.xml

# Set permissions
chmod 644 %{_sysconfdir}/prolingaruncfg.xml

%post server
# Add prolingarund as service
/sbin/chkconfig --add prolingarund

%preun server
if [ "$1" -eq 0 ]; then
    /sbin/service prolingarund stop > /dev/null 2>&1
    /sbin/chkconfig --del prolingarund
fi
exit 0

%postun
# update library links
/sbin/ldconfig

%postun server
if [ "$1" -ge 1 ]; then
    /sbin/service prolingarund condrestart > /dev/null 2>&1
fi
exit 0

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README NEWS
%doc doc/html
%{_bindir}/prolinga
%{_bindir}/prolingarun
%{_bindir}/prolingarunclient
%{_libdir}/libprolingarun-*.so.*
%{_sysconfdir}/prolingaruncfg.xml

%files server
%{_bindir}/prolingarund
%config /etc/rc.d/init.d/*

%files devel
%defattr(-, root, root)
%doc doc/*.xml doc/*.xsl doc/*.txt
%{_includedir}/prolinga
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%changelog
* Wed Sep 02 2009 Bas Driessen <bas.driessen@xobas.com> 0.0.2-1.sa.fc11
- Build for Fedora 11.
- New upstream release.
- Move repository system path to localstatedir.
- Add memory corruption fix patch.

* Tue May 20 2008 Bas Driessen <bas.driessen@xobas.com> 0.0.1-2.sa.fc9
- Build for Fedora 9.
- Changed requirement libglade -> libglade2.

* Mon Mar 24 2008 Bas Driessen <bas.driessen@xobas.com> 0.0.1-1.sa.fc8
- Initial spec file.



